| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Macros | Functions
Device Management (EFM32GG)
Device Management

USB Device definitions for the EFM32 Giant Gecko microcontrollers. More...

## Macros
#define | INTERNAL_SERIAL_LENGTH_BITS 120
#define | INTERNAL_SERIAL_START_ADDRESS 0x80800204
#define | USE_INTERNAL_SERIAL 0xDC

## Functions
static void | USB_Device_DisableSOFEvents (void) ATTR_ALWAYS_INLINE
static void | USB_Device_EnableSOFEvents (void) ATTR_ALWAYS_INLINE
static uint16_t | USB_Device_GetFrameNumber (void) ATTR_ALWAYS_INLINE ATTR_WARN_UNUSED_RESULT
void | USB_Device_SendRemoteWakeup (void)

## USB Device Mode Option Masks
#define | USB_DEVICE_OPT_LOWSPEED (1 << 0)
#define | USB_DEVICE_OPT_FULLSPEED (0 << 0)
#define | USB_DEVICE_OPT_HIGHSPEED (1 << 1)

## Detailed Description

Architecture specific USB Device definitions for the Silabs 32-bit EFM32 Giant Gecko microcontrollers.

## Macro Definition Documentation

#define INTERNAL_SERIAL_LENGTH_BITS 120

Length of the device's unique internal serial number, in bits, if present on the selected microcontroller model.

#define INTERNAL_SERIAL_START_ADDRESS 0x80800204

Start address of the internal serial number, in the appropriate address space, if present on the selected microcontroller model.

#define USB_DEVICE_OPT_FULLSPEED (0 << 0)

Mask for the Options parameter of the USB_Init() function. This indicates that the USB interface should be initialized in full speed (12Mb/s) mode.

#define USB_DEVICE_OPT_HIGHSPEED (1 << 1)

Mask for the Options parameter of the USB_Init() function. This indicates that the USB interface should be initialized in high speed (480Mb/s) mode.

#define USB_DEVICE_OPT_LOWSPEED (1 << 0)

Mask for the Options parameter of the USB_Init() function. This indicates that the USB interface should be initialized in low speed (1.5Mb/s) mode.

Note
  Restrictions apply on the number, size and type of endpoints which can be used when running in low speed mode - please refer to the USB 2.0 specification.

#define USE_INTERNAL_SERIAL 0xDC

String descriptor index for the device's unique serial number string descriptor within the device. This unique serial number is used by the host to associate resources to the device (such as drivers or COM port number allocations) to a device regardless of the port it is plugged in to on the host. Some microcontrollers contain a unique serial number internally, and setting the device descriptors serial number string index to this value will cause it to use the internal serial number.

On unsupported devices, this will evaluate to NO_DESCRIPTOR and so will force the host to create a pseudo-serial number for the device.

## Function Documentation

static void USB_Device_DisableSOFEvents | ( | void |  | ) |
| inline static

Disables the device mode Start Of Frame events. When disabled, this stops the firing of the EVENT_USB_Device_StartOfFrame() event when enumerated in device mode.

Note
  Not available when the `NO_SOF_EVENTS` compile time token is defined.

static void USB_Device_EnableSOFEvents | ( | void |  | ) |
| inline static

Enables the device mode Start Of Frame events. When enabled, this causes the EVENT_USB_Device_StartOfFrame() event to fire once per millisecond, synchronized to the USB bus, at the start of each USB frame when enumerated in device mode.

Note
  Not available when the `NO_SOF_EVENTS` compile time token is defined.

static uint16_t USB_Device_GetFrameNumber | ( | void |  | ) |
| inline static

Returns the current USB frame number, when in device mode. Every millisecond the USB bus is active (i.e. enumerated to a host) the frame number is incremented by one.

Returns
  Current USB frame number from the USB controller.

void USB_Device_SendRemoteWakeup | ( | void |  | ) |

Sends a Remote Wakeup request to the host. This signals to the host that the device should be taken out of suspended mode, and communications should resume.

Typically, this is implemented so that HID devices (mice, keyboards, etc.) can wake up the host computer when the host has suspended all USB devices to enter a low power state.

Note
  This function should only be used if the device has indicated to the host that it supports the Remote Wakeup feature in the device descriptors, and should only be issued if the host is currently allowing remote wakeup events from the device (i.e., the USB_Device_RemoteWakeupEnabled flag is set). When the `NO_DEVICE_REMOTE_WAKEUP` compile time option is used, this function is unavailable.
  The USB clock must be running for this function to operate. If the stack is initialized with the USB_OPT_MANUAL_PLL option enabled, the user must ensure that the PLL is running before attempting to call this function.

See also
  USB Descriptors for more information on the RMWAKEUP feature and device descriptors.